new;
library tsm,optmum,pgraph;
TSMset;

load y = pigen;

y = packr(y);

d = zeros(5,1);
H = zeros(5,5);
T = eye(6);
c = zeros(6,1);
R = eye(6);

a0 = 0|y[1,.]';
P0 = zeros(6,6);

/* Compute the log-likelihood in the time domain */

proc ml(theta);
  local beta,sigma,Z,Q,logl;

  beta = theta[1:5];
  sigma = theta[6:11]^2;

  Z = beta~eye(5);
  Q = diagrv(zeros(6,6),sigma);

  call SSM_build(Z,d,H,T,c,R,Q,0); /* Build the state space model */
  call KFiltering(y,a0,P0);        /* Run the Kalman filter       */
  logl = KF_ml;              /* Compute the log-likelihood vector */

  retp(logl);
endp;


/* Estimation of the parameters vector */

sv = ones(11,1);
_tsm_Mcov = 1;
{theta,stderr,Mcov,Logl} = TD_ml(&ml,sv);

beta = theta[1:5];
sigma = theta[6:11]^2;

Z = beta~eye(5);
Q = diagrv(zeros(6,6),sigma);

call SSM_build(Z,d,H,T,c,R,Q,0); /* Build the state space model */
call KFiltering(y,a0,P0);        /* Run the Kalman filter       */
at = KF_matrix(3);               /* Read the state vectors a(t) */

graphset;
  _pdate = ""; _pnum = 2;
  lab=" [1817] [1818] [1819] [1820] [1821] "\
      " [1822] [1823] [1824] [1825] [1826] [1827] [1828] "\
      " [1829] [1830] [1831] [1832] [1833] [1834] [1835] "\
      " [1836] [1837] [1838] [1839] [1840] [1841] ";
  asclabel(lab,0);
  xtics(1,300,12,4);
  title("Common component"\
        "\Lregional inflation rates"\
        "\L(1817-1841)");
  _pltype = 6;
  _plwidth = 5;
  xy(seqa(1,1,rows(at)),at[.,1]);


