new;

Ns = 10000;

K = rnd(90,100,Ns);
F0 = rnd(90,100,Ns);
sigma = rnd(0.02,0.04,Ns);
r = rnd(0.05,0.10,Ns);
tau = rnd(30/365,2,Ns);

Prime = CALL_future(K,F0,sigma,tau,r);

data = Prime~K~F0~r~tau~sigma;
save data;

proc rnd(a,b,Ns);
  retp(a+(b-a)*rndu(Ns,1));
endp;


proc CALL_future(K,F0,sigma,tau,r);
  local a,b,d1,d2,prime;

  a = sigma.*sqrt(tau);
  d1 = ln(F0./K)./a + 0.5*a;
  d2 = d1 - a;
  b = exp(-r.*tau);


  prime = F0.*b.*cdfn(d1) - K.*b.*cdfn(d2);

  retp(prime);
endp;



