new;
library pgraph;

#include tridiag.src;
#include edp2.src;

proc mu(x);
  retp(0.10-x);
endp;

proc sigma(x);
  retp(0.1);
endp;

proc lambda(x);
  retp(0.1);
endp;

proc alpha(x);
  retp(x);
endp;

_print =1;
cn = -1|1|100|5|500|0;

{t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,0,cn);
r = x[56]; sol=u[56,.]';
{t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,0.25,cn); sol=sol~u[56,.]';
{t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,0.5,cn); sol=sol~u[56,.]';
{t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,0.75,cn); sol=sol~u[56,.]';
{t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,1,cn); sol=sol~u[56,.]';

P = vasicek(t,1,0.10,0.1,r,0.1);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _plwidth = 5; _paxht = 0.2; _pnum = 2;
  title("Methode des \202Q\201-schemas");
  xlabel("\202t\201"); ylabel("P-u[n]]j[");
  _plegstr = "\202Q\201=0\000\202Q\201=0.25\000\202Q\201=0.5\000"\
             "\202Q\201=0.75\000\202Q\201=1";
  _plegctl = { 2 6 6 1.5};
  xy(t,P-sol);


proc vasicek(tau,a,b,sigma,r0,lamda);
  local b_prime,taux_long,x,c;
  b_prime=b-lamda.*sigma./a;
  taux_long=b_prime-(sigma^2)./(2*a^2);
  x=(1-exp(-a.*tau))./a;
  c=exp(-taux_long.*tau+(taux_long-r0).*x-(x^2).*(sigma^2)./(4*a));
  retp(c);
endp;

