new;
library pgraph;

#include tridiag.src;
#include edp2.src;

proc mu(t,x);
  retp(0.10-x);
endp;

proc sigma(t,x);
  retp(0.1);
endp;

proc lambda(t,x);
  retp(0.1);
endp;

proc alpha(t,x);
  retp(x);
endp;

_print =1;

np = seqa(100,100,5);
axe1 = miss(zeros(501,5),0);
sol1 = miss(zeros(501,5),0);

i=1;
do until i>5;
  cn = -1|1|100|5|np[i]|1;
  {t,x,u} = EDP2(&mu,&sigma,&lambda,&alpha,0.25,cn);
  r = x[56];
  P = vasicek(t,1,0.10,0.1,r,0.1);
  sol1[1:rows(P),i] = P-u[56,.]';
  axe1[1:rows(t),i] = t;
  i = i+1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _plwidth = 5; _paxht = 0.2; _pnum = 2;
  title("Influence de k");
  xlabel("\202t\201"); ylabel("P-u[n]]j[");
  _plegstr = "k=0.05\000k=0.025\000k=0.0167\000"\
             "k=0.0125\000k=0.01";
  _plegctl = { 2 6 2 4};
  xy(axe1,sol1);


proc vasicek(tau,a,b,sigma,r0,lamda);
  local b_prime,taux_long,x,c;
  b_prime=b-lamda.*sigma./a;
  taux_long=b_prime-(sigma^2)./(2*a^2);
  x=(1-exp(-a.*tau))./a;
  c=exp(-taux_long.*tau+(taux_long-r0).*x-(x^2).*(sigma^2)./(4*a));
  retp(c);
endp;


