new;
library pgraph;

#include hjm.src;

sigma2 = 0.05;
lambda = 0.125;

proc beta(t,_T);
  local res;
  res = sigma2.*exp(-lambda/2.*(_T-t));
  retp(res);
endp;

proc solution(t);
  local y;
  y = -2*(sigma2/lambda)^2*( (1-exp(-lambda*t)) - 2*(1-exp(-lambda/2*t)) );
  retp(y);
endp;

N = 5|10|25|50;
ch = "Sol";

j = 1;
do until j > 4;

_N = N[j];
_T = 140;
t = seqa(0.1,0.5,_T);
r = zeros(_T,2);
i = 1;
do until i > _T;
  r[i,.] = HJM(&beta,0,t[i])~solution(t[i]);
  i = i+1;
endo;
call varput(r,ch$+ftos(j,"%lf",1,0));
j = j+1;
endo;

graphset;
begwind;
window(2,2,0);
setwind(1);
  _ptitlht = 0.25; _paxht = 0.25; _pnum = 2; _pnumht = 0.20; _plwidth = 5;
  title("N=5");
  _plegstr = "Solution Numerique\0Solution Exacte";
  _plegctl = { 2 6 3.5 2};
  xlabel("t");
  r = varget("Sol1");
  xy(t,r);
nextwind;
  title("N=10");
  r = varget("Sol2");
  xy(t,r);
nextwind;
  graphset;
  _ptitlht = 0.25; _paxht = 0.25; _pnum = 2; _pnumht = 0.20; _plwidth = 5;
  title("N=25");
  xlabel("t"); ylabel("ERREUR");
  r = varget("Sol3");
  xy(t,r[.,2]-r[.,1]);
nextwind;
  title("N=50");
  r = varget("Sol4");
  xy(t,r[.,2]-r[.,1]);
endwind;


