new;
#include markov.src;

hsec_ = hsec;

K = 98;
S0 = 100;
sig = 0.15;
t0 = 0;
TT = 95/365;
tau = TT - t0;
r = ln(1+0.08);

Prime = 5.3677;   /* Valeur de la prime de l'option d'achat dans
                     le modele de Black et Scholes */

proc mu(x);
  retp(r*x);
endp;

proc sigma(x);
  retp(sig*x);
endp;

S_min = 80;
S_max = 120;
Ns = 100;     /* Nombre de points pour la partition de S */
Nt = 50;      /* Nombre de points pour la partition du temps */

cn = S_min|S_max|Ns|(tau/Nt);

{S,P} = EDS_to_MarkovChain(&mu,&sigma,cn);

Prob = P;

i = 1;
do until i > Nt;
  Prob = Prob*P;
  i = i + 1;
endo;

indx = indexcat(S,S0);
Prob = Prob[indx,.]';

PayOff = S - K;
PayOff = PayOff.*(PayOff.>0);
C = exp(-r*tau)*(Prob'PayOff);

output file = markov.out reset;

print ftos(Prime,"Valeur de la prime de l'option d'achat : %lf",5,4);
print ftos(C,"Valeur approchee par la chaine de Markov : %lf",5,4);

print;
print ftos((hsec-hsec_)/100,"Temps de calcul : %lf secondes",5,3);

output off;





