new;
library tsm,optmum,pgraph;
TSMset;

output file = mcarlo.out reset;
tt = hsec;

#include asian.src;

MC1 = zeros(250,3);    /* avec accelerateur de Monte Carlo */
MC2 = zeros(250,3);    /* sans accelerateur de Monte Carlo */
_print = 0;

rndseed 123; _accelerateur = 1;

i = 1;
do until i > 250;
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,5);
  MC1[i,1] = Prime[5];
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,25);
  MC1[i,2] = Prime[5];
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,100);
  MC1[i,3] = Prime[5];
  i = i+1;
endo;

rndseed 123; _accelerateur = 0;

i = 1;
do until i > 250;
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,5);
  MC2[i,1] = Prime[5];
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,25);
  MC2[i,2] = Prime[5];
  Prime = CRR_asian(100,98,90/365,0.2,0.08,3,100);
  MC2[i,3] = Prime[5];
  i = i+1;
endo;


x1 = zeros(128,3); x2 = x1;
d1 = zeros(128,3); d2 = d1;

i = 1;
do until i > 3;
  {x1[.,i],d1[.,i],F,retcode} = Kernel(MC1[.,i]);
  {x2[.,i],d2[.,i],F,retcode} = Kernel(MC2[.,i]);
  i = i + 1;
endo;

print ftos((hsec-tt)/100,"Temps de calcul : %lf secondes",10,5);

output off;

graphset;
  TITLE("Fonction de densite (avec accelerateur de Monte Carlo)");
  _plwidth = 6;
  _pdate = "";
  _pline = 1~1~6.3957115~0~6.3957115~10~1~7~10;
  _plegstr = "Ns = 5\000Ns = 25\000Ns = 100";
  _plegctl = {2 7 6 3};
  xtics(0,18,2,0); ytics(0,1.2,0.4,0);
  xy(x1,d1);

graphset;
  TITLE("Fonction de densite (sans accelerateur de Monte Carlo)");
  _plwidth = 6;
  _pdate = "";
  _pline = 1~1~6.3957115~0~6.3957115~10~1~7~10;
  _plegstr = "Ns = 5\000Ns = 25\000Ns = 100";
  _plegctl = {2 7 6 3};
  xtics(0,18,2,0); ytics(0,1.2,0.4,0);
  xy(x2,d2);



