new;
library pgraph;

#include poisson.src;

rndseed 123;

L = 1000;
t0 = 0;
TT = 10;
lambda = 5;
{t,N} = Poisson(lambda,t0,TT,L,1);
{t,N2} = Poisson(2,t0,TT,L,1);

graphset;
  fonts("simplex simgrma");
  _pdate = "";
  _plwidth = 5; _pnum = 2;
  title("Simulation de processus de Poisson"\
        "\L__ \202l\201 = 5    _ _ \202l\201 = 2");
  xtics(t0,TT,1,0);
  ytics(0,50,10,0);
  xs = t[1:L];
  xe = t[2:L+1];
  ys = N[1:L];
  ye = N[1:L];
  e = ones(L,1);

  p1 = e~6*e~xs~ys~xe~ye~0*e~7*e~0*e;

  ys = N2[1:L];
  ye = N2[1:L];

  p2 = e~3*e~xs~ys~xe~ye~0*e~7*e~0*e;

  _pline = p1|p2;

  xlabel("t");
  ylabel("N]t[(\202w\201)");
  draw;


M = N - lambda*t;

graphset;
  fonts("simplex simgrma");
  _pdate = "";
  _plwidth = 5; _pnum = 2;
  title("Processus de Poisson precedent d'intensite \202l \201= 5"\
        "\LM]t[ = N]t[ - \202l\201t est une martingale");
  xtics(t0,TT,1,0);
  ytics(-11,1,1,0);
  xs = t[1:L];
  xe = t[2:L+1];
  ys = M[1:L];
  ye = M[1:L];
  e = ones(L,1);

  _pline = e~6*e~xs~ys~xe~ye~0*e~7*e~0*e;

  xlabel("t");
  ylabel("M]t[(\202w\201)");
  draw;


V = M^2 - lambda*t;

graphset;
  fonts("simplex simgrma");
  _pdate = "";
  _plwidth = 5; _pnum = 2;
  title("Processus de Poisson precedent d'intensite \202l \201= 5"\
        "\LV]t[ = M]t[ - \202l\201t est une martingale");
  xtics(t0,TT,1,0);
  ytics(-40,80,10,0);
  xs = t[1:L];
  xe = t[2:L+1];
  ys = V[1:L];
  ye = V[1:L];
  e = ones(L,1);

  _pline = e~6*e~xs~ys~xe~ye~0*e~7*e~0*e;

  xlabel("t");
  ylabel("V]t[(\202w\201)");
  draw;

