new;
library pgraph;

#include saut.src;

x0 = 2;

proc mu(t,x);
  retp(0.0002*x);
endp;

proc sigma(t,x);
  retp(1.09*x);
endp;

proc kappa(t,x);
  retp(1);
endp;

proc lambda1(t,x);
  retp(0);
endp;

rndseed 123;
{t,x1,dN} = saut(x0,&mu,&sigma,&kappa,&lambda1,0,10,100,1);

proc lambda2(t,x);
  if t <= 5;
    retp(1);
  else;
    retp(0.5);
  endif;
endp;

rndseed 123;
{t,x2,dN} = saut(x0,&mu,&sigma,&kappa,&lambda2,0,10,100,1);
xs2 = indexcat(dN[.,1],1);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2;
  title("Mouvement Brownien Geometrique : "\
        "dX]t[ = \202m\201X]t[dt + \202s\201X]t[dW]t["\
        "\LProcessus de saut : "\
        "dX]t[ = \202m\201X]t[dt + \202s\201X]t[dW]t[ +\202k\201]t[dN]t[");
  xs = t[xs2];
  e = ones(rows(xs),1);
  xe = xs;
  ys = e*0;
  ye = e*100;

  _pline = e~6*e~xs~ys~xe~ye~0*e~7*e~0*e;

  xs = t[xs2-1];
  e = ones(rows(xs),1);
  xe = xs;
  ys = e*0;
  ye = e*100;

  _pline = _pline|(e~6*e~xs~ys~xe~ye~0*e~7*e~0*e);
  xy(t,x1~x2);

