new;
library tsm,optmum;
TSMset;

load x = eds;

Nobs = rows(x);
h = 0.1;

proc ml1(theta);
  local a,b,sigma,k1,k2,e,logl;

  a = theta[1]; b = theta[2]; sigma = theta[3];
  k1 = exp(-a*h);
  k2 = sigma^2*(1-exp(-2*a*h))/(2*a);
  e = x[2:1000]-k1.*x[1:999]-b*(1-k1);
  logl = -0.5*ln(2*pi) - 0.5*ln(k2) - 0.5*e^2/k2;

  retp(logl);
endp;

proc ml2(theta);
  local a,b,sigma,et,vt,logl;

  a = theta[1]; b = theta[2]; sigma = theta[3];

  et = x[2:Nobs] - x[1:Nobs-1] - a*(b-x[1:Nobs-1])*h;
  vt = (sigma^2)*h;

  logl = -0.5*ln(2*pi) - 0.5*ln(vt) - 0.5*et^2./vt;

  retp(logl);
endp;


output file = eds1.out reset;

_tsm_parnm = "a"|"b"|"sigma";

sv = 0.5|0.5|0.5;
{theta,stderr,Mcov,Logl} = TD_ml(&ml1,sv);

print; print;
{theta,stderr,Mcov,Logl} = TD_ml(&ml2,theta);

output off;


