new;
library tsm,optmum,finance,pgraph;

r = 3.50/100;       /* Taux d'interet national */
rstar = 3.10/100;   /* Taux d'interet etranger */
K = 3.35;           /* Prix d'exercice         */
sigma = 0.05;       /* Volatilite              */
tau = 90/365;       /* Maturite 90 jours       */

S0 = seqa(3.30,0.01,21);

Merton1 = 100*Merton(S0,K,sigma,tau,r,rstar,1.1,0.05,10);
Merton2 = 100*Merton(S0,K,sigma,tau,r,rstar,1.1,0.5,10);
Merton3 = 100*Merton(S0,K,sigma,tau,r,rstar,0.8,1,10);

Malz1 = 100*_Malz(S0,K,sigma,tau,r,rstar,1.1,0.05,1);
Malz2 = 100*_Malz(S0,K,sigma,tau,r,rstar,1.1,0.5,1);
Malz3 = 100*_Malz(S0,K,sigma,tau,r,rstar,0.8,1,1);


err1 = Malz1./Merton1 - 1;
err2 = Malz2./Merton2 - 1;
err3 = Malz3./Merton3 - 1;


graphset;
  fonts("simplex simgrma");
  title("Comparaison Modele de Merton / Modele de Malz");
  _pdate = ""; _pnum = 2; _plwidth = 0|0|10;
  ylabel("Erreur d'approximation (en %)");
  xlabel("Prix du sous-jacent");
  _plegstr = "\202F\201=1.1 \202l\201=0.05"\
             "\0\202F\201=1.1 \202l\201=0.5"\
             "\0\202F\201=0.8 \202l\201=1";
  _plegctl = {2 5 5.5 3};
  xy(S0,err1~err2~err3);


