new;
library finance,tsm,optmum,pgraph;

rndseed 123;

r = 3.50/100;       /* Taux d'interet national */
rstar = 3.10/100;   /* Taux d'interet etranger */
vol = 0.05;         /* Volatilite              */
tau = 90/365;       /* Maturite 90 jours       */

Nobs = 25;
K = 3.25 + 0.20*rndu(Nobs,1);
S0 = 3.25 + 0.20*rndu(Nobs,1);
type_option = rndu(Nobs,1) .< 0.5;
Prime = _Garman_Kohlhagen(S0,K,vol,tau,r,rstar,type_option);

let parname = "sigma" "theta" "lambda";

output file = malz2.out reset;

{sigma,theta,lambda} = Malz(S0,K,tau,r,rstar,type_option,Prime,0,0);

print "Estimation non contrainte";
print;
omat = parname~(vol|1|0)~(sigma|theta|lambda);
print "              val. theorique    estimation ";
print "-------------------------------------------";
call printfmt(omat,0~1~1);
print;
print ftos(lambda*tau,"Probabilite de realignement : %lf",5,3);
print ftos(lambda*(theta-1),"Ampleur anticipee du saut : %lf",5,3);


CC = 0~1~0; c = 1.025;
{sigma,theta,lambda} = Malz(S0,K,tau,r,rstar,type_option,Prime,CC,c);

print; print;
print "Estimation contrainte";
print;
omat = parname~(vol|1|0)~(sigma|theta|lambda);
print "              val. theorique    estimation ";
print "-------------------------------------------";
call printfmt(omat,0~1~1);
print;
print ftos(lambda*tau,"Probabilite de realignement : %lf",5,3);
print ftos(lambda*(theta-1),"Ampleur anticipee du saut : %lf",5,3);

output off;
