new;
library finance;

proc (2) = Information(N);
  local mu,P,V;

  mu = rndu(N,1);
  P = lowmat(xpnd(rndn(N*(N+1)/2,1)));
  V = P*P';

  retp(mu,V);
endp;

output file = markow4.out reset;

print "Nombre d'Actifs    Temps de calcul (en secondes)";
print "------------------------------------------------";

N = 25|50|75|100|150|200|250|300;

i = 1;
do until i > rows(N);

  {mu,V} = Information(N[i]);

  debut = hsec;
  {alpha,RP,SigmaP} = Markowitz(mu,V,20);
  Temps_de_Calcul = (hsec-debut)/100;
  str = ftos(N[i],"      %lf",4,0);
  str = str $+ ftos(Temps_de_Calcul,"                   %lf",6,3);
  print str;

  i = i + 1;
endo;

output off;

