new;
library finance,pgraph;

r = 3.50/100;       /* Taux d'interet national */
rstar = 3.10/100;   /* Taux d'interet etranger */
K = 3.35;           /* Prix d'exercice         */
sigma = 0.05;       /* Volatilite              */
tau = 90/365;       /* Maturite 90 jours       */

S0 = seqa(3.30,0.01,21);

GK = 100*Garman_Kohlhagen(S0,K,sigma,tau,r,rstar);
M1 = 100*Merton(S0,K,sigma,tau,r,rstar,1.1,0.05,10);
M2 = 100*Merton(S0,K,sigma,tau,r,rstar,1.1,0.5,10);

BD = 100*Borensztein_Dooley(S0,K,-0.08,tau,1.1,r,rstar);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _plwidth = 0|0|10|0;
  ylabel("Prime de 100 options d'achat");
  xlabel("Prix du sous-jacent");
  _plegstr = "GK\0BD (\202m\201=-0.08 \202F\201=1.1)"\
     "\0Merton (\202F\201=1.1 \202l\201=0.05)"\
     "\0Merton (\202F\201=1.1 \202l\201=0.5)";
  _plegctl = {2 5 1.25 4};
  xy(S0,GK~BD~M1~M2);
