new;
library tsm,optmum,finance,pgraph;

F0 =  100;
sigma = 0.15;
tau = 90/360;
r = 0.10;

K = seqa(90,1,20);

/* Probabilite theorique dans le modele de Black [1976] */

mu = ln(F0) - 0.5*sigma^2.*tau;
V = sigma^2.*tau;
x = (ln(K)-mu)./sqrt(V);
Probabilite_Theorique = cdfn(x);

/* Probabilite estimee a partir de la derivee premiere
   de la prime du call par rapport au prix d'exercice  */

proc _call(K);
  local C;
  _type_option = "call";
  C = Black(F0,K,sigma,tau,r);
  retp(C);
endp;

Probabilite_Estimee = 1 + exp(r*tau)*diag(gradp(&_call,K));


graphset;
  begwind;
  window2(1,2,0,1);
  setwind(1);

    _pdate = ""; _ptitlht = 1.25; _pnum = 0; _paxes = 0;
    title("Estimation de Prob{F(T)<K}"\
          "\Lsous la mesure de probabilite neutre au risque");
    draw;

  setwind(2);
    graphset;
    _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;
    title("Probabilite theorique");
    xlabel("K");
    xtics(90,110,5,5);
    xy(K,Probabilite_Theorique);
  setwind(3);
    title("Probabilite estimee");
    xy(K,Probabilite_Estimee);
  endwind;
