new;
library tsm,optmum,finance,pgraph;

F0 = 100;
K = 110;
sigma = 0.15;
tau = 90/360;
r = 0.10;

Future = seqa(85,0.5,60);

/* Fonction de densite de ln(F) theorique dans le modele de Black [1976] */

mu = ln(F0) - 0.5*sigma^2.*tau;
V = sigma^2.*tau;
x = (ln(Future)-mu)./sqrt(V);
pdf_Theorique = pdfn(x)./sqrt(V);

/* Fonction de densite de ln(F) estimee a partir de la derivee seconde
   de la prime du call par rapport au prix d'exercice                  */

proc _call(K);
  local C;
  _type_option = "call";
  C = Black(F0,K,sigma,tau,r);
  retp(C);
endp;

pdf_Estimee = zeros(60,1);
i = 1;
do until i > 60;
  pdf_Estimee[i] = exp(r*tau+ln(Future[i]))*hessp(&_call,Future[i]);
  i = i + 1;
endo;


graphset;
  begwind;
  window2(1,2,0,1);
  setwind(1);

    _pdate = ""; _ptitlht = 1.2; _pnum = 0; _paxes = 0;
    title("Estimation de la mesure de probabilite neutre au risque\Lde ln(F)");
    draw;

  setwind(2);
    graphset;
    _pnum = 2; _pnumht = 0.25; _paxht = 0.25; _ptitlht = 0.25;
    title("Fonction de densite theorique");
    xlabel("LN(F)");
    xy(ln(Future),pdf_Theorique);
  setwind(3);
    title("Fonction de densite estimee");
    xy(ln(Future),pdf_Estimee);
  endwind;


